import matplotlib.pyplot as plt
import matplotlib

for p in [.1,.2,.3,.4,.5,.6,.7,.8,.9,.95]:
    data = []
    for s in [1,2,3,4,5,6,7,8,9,10]:
        data = data + [1.0/((1-p) + (p/s))]
    plt.plot([1,2,3,4,5,6,7,8,9,10], data, label="p=%.1f"%(p))

SMALL_SIZE = 12
MEDIUM_SIZE = 14
BIGGER_SIZE = 18

plt.rc('font', size=SMALL_SIZE)          # controls default text sizes
plt.rc('axes', titlesize=SMALL_SIZE)     # fontsize of the axes title
plt.rc('axes', labelsize=MEDIUM_SIZE)    # fontsize of the x and y labels
plt.rc('xtick', labelsize=SMALL_SIZE)    # fontsize of the tick labels
plt.rc('ytick', labelsize=SMALL_SIZE)    # fontsize of the tick labels
plt.rc('legend', fontsize=SMALL_SIZE)    # legend fontsize
plt.rc('figure', titlesize=BIGGER_SIZE)  # fontsize of the figure title

plt.legend()
plt.xlabel("Optimized Component Speedup (s)")
plt.ylabel("Total System Speedup (slatency)")
plt.title("Amdahl's law for varying p and s")
plt.show()