#include <stdio.h>
#include <stdlib.h>
#include <string.h>
 #include <time.h>
     

#define PATH "indiv20/by_date/itcont_2020_20010425_20190425.txt"
#define HEADER "CMTE_ID,AMNDT_IND,RPT_TP,TRANSACTION_PGI,IMAGE_NUM,TRANSACTION_TP,ENTITY_TP,NAME,CITY,STATE,ZIP_CODE,EMPLOYER,OCCUPATION,TRANSACTION_DT,TRANSACTION_AMT,OTHER_ID,TRAN_ID,FILE_NUM,MEMO_CD,MEMO_TEXT,SUB_ID"

int num_toks(char *line, char *delim) {
    char *tok;
    int i = 0;
    char *cpy = malloc(strlen(line) + 1);
    strcpy(cpy, line);
    tok = strtok(cpy, delim);
    while( tok != NULL )
    {
        fflush(stdout);
        tok = strtok( NULL, delim );
        i = i + 1;
    }
    free(cpy);
    return i;

}

//note, this modifies *line by adding nulls between tokens
char **fields(char *line, int num_toks, char *delim) { 

    char *tok;
    char **result;
    int i = 0;

    result = malloc(sizeof(char *) * num_toks);
    tok = strtok(line, delim);
    while( tok != NULL && i < num_toks)
    {
        result[i++] = tok;
        tok = strtok( NULL, delim);
    }
    return result;
}

int find_idx(char **ar, char *search, int nfields) {
    for(int i = 0; i < nfields; i++) {
        fflush(stdout);
        if (strcmp(ar[i], search) == 0) {
            return i;
        }
    }
    return -1;
}

char * readfile(FILE *f) {
    fseek(f, 0, SEEK_END);
    long fsize = ftell(f);
    fseek(f, 0, SEEK_SET);  /* same as rewind(f); */

    char *string = malloc(fsize + 1);
    fread(string, 1, fsize, f);
    fclose(f);

    string[fsize] = 0;
    return string;
}


int main() {
    FILE *f = fopen(PATH, "r");
    char *line;
    size_t len = 0;
    ssize_t read;
    int i = 0;
    char ***lines;
    char *hdr = malloc(strlen(HEADER) + 1);
    char **hdr_fields;
     clock_t start, end;
     double init_time, read_time, scan_time, parse_time;
     

    strcpy(hdr, HEADER);
    int ntoks = num_toks(hdr,",");
    hdr_fields = fields(hdr, ntoks, ",");

     start = clock();
    int name_idx = find_idx(hdr_fields, "NAME", ntoks);
    int employer_idx = find_idx(hdr_fields, "EMPLOYER", ntoks);
    int xaction_amt_idx = find_idx(hdr_fields, "TRANSACTION_AMT", ntoks);

    lines = malloc(sizeof(char **) * 2000000);
     end = clock();
     init_time = ((double) (end - start)) / CLOCKS_PER_SEC;
     start = clock();

    char *data = readfile(f);

    end = clock();
    read_time = ((double) (end - start)) / CLOCKS_PER_SEC;

    start = clock();
    line = malloc(200);
    while(1)
    {
      char * line = strchr(data, '\n');
      if (line)  {
        *line = '\0';  
        int len = strlen(data);
        lines[i++] = fields(data,ntoks, "|");
        data += len + 1;


      } else {
        break;
      }
   }

     end = clock();
     parse_time = ((double) (end - start)) / CLOCKS_PER_SEC;

    printf("got %d\n", i);
    // char **row = lines[1];
    // for (int i = 0; i < ntoks; i++) {
    //     printf("%d = %s\n", i, row[i]);
    // }
     start = clock();
    char **row;
    for (int j = 0; j < i; j++) {
        row = lines[j];

        if (strstr(row[name_idx], "MADDEN") != NULL) {
            printf("%s %s %s\n", row[name_idx], row[employer_idx], row[xaction_amt_idx]);
            // for (int k = 0; k < ntoks; k++) {
            //     printf("%s = %s\n", hdr_fields[k], row[k]);
            // }
        }
    }
     end = clock();
     scan_time = ((double) (end - start)) / CLOCKS_PER_SEC;

     printf("init_time = %.2fs, read_time = %.2fs, parse_time = %.2fs, scan_time = %.2fs\n", init_time, read_time, parse_time, scan_time);



}