#include <stdio.h>
#include <stdlib.h>
#include <string.h>
 #include <time.h>
     

#define PATH "indiv20/by_date/itcont_2020_20010425_20190425.txt"
#define HEADER "CMTE_ID,AMNDT_IND,RPT_TP,TRANSACTION_PGI,IMAGE_NUM,TRANSACTION_TP,ENTITY_TP,NAME,CITY,STATE,ZIP_CODE,EMPLOYER,OCCUPATION,TRANSACTION_DT,TRANSACTION_AMT,OTHER_ID,TRAN_ID,FILE_NUM,MEMO_CD,MEMO_TEXT,SUB_ID"

int num_toks(char *line, char *delim) {
    char *tok;
    int i = 0;
    char *cpy = malloc(strlen(line) + 1);
    strcpy(cpy, line);
    tok = strtok(cpy, delim);
    while( tok != NULL )
    {
        fflush(stdout);
        tok = strtok( NULL, delim );
        i = i + 1;
    }
    free(cpy);
    return i;

}

//return an array of tokens from the input line
//returned tokens are pointers into line
//also,  modifies line by adding nulls between tokens in place of delimiters
char **fields(char *line, int num_toks, char *delim) {
    char *tok;
    char **result;
    int i = 0;

    result = malloc(sizeof(char *) * num_toks);
    tok = strtok(line, delim);;
    while( tok != NULL && i < num_toks)
    {
        result[i++] = tok;
        tok = strtok( NULL, delim);
    }
    return result;
}

//return the index of the element equal to search in ar, or -1 if no such element exists
int find_idx(char **ar, char *search, int nfields) {
    for(int i = 0; i < nfields; i++) {
        fflush(stdout);
        if (strcmp(ar[i], search) == 0) {
            return i;
        }
    }
    return -1;
}


int main() {
    FILE *f = fopen(PATH, "r");
    char * line = NULL;
    size_t len = 0;
    ssize_t read;
    int i = 0;
    char ***lines;
    char *hdr = malloc(strlen(HEADER) + 1);
    char **hdr_fields;


    //parse the header
    strcpy(hdr, HEADER);
    int ntoks = num_toks(hdr,",");
    hdr_fields = fields(hdr, ntoks, ",");

    int name_idx = find_idx(hdr_fields, "NAME", ntoks);
    int employer_idx = find_idx(hdr_fields, "EMPLOYER", ntoks);
    int xaction_amt_idx = find_idx(hdr_fields, "TRANSACTION_AMT", ntoks);


    //read the lines and store in an array of line pointers
    lines = malloc(sizeof(char **) * 2000000);

    while ((read = getline(&line, &len, f)) != -1) {
        lines[i++] = fields(line,ntoks, "|");
        line = NULL;
        len = 0;
    }


    //scan the lines and find the ones that contain MADDEN in the name field
    printf("got %d\n", i);
    char **row;
    for (int j = 0; j < i; j++) {
        row = lines[j];
        if (strstr(row[name_idx], "MADDEN") != NULL) {
            printf("%s %s %s\n", row[name_idx], row[employer_idx], row[xaction_amt_idx]);
        }
    }


}